/* -*- C++ -*-
 * src/lemon/lp_skeleton.cc
 * - Part of LEMON, a generic C++ optimization library
 *
 * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
 * (Egervary Combinatorial Optimization Research Group, EGRES).
 *
 * Permission to use, modify and distribute this software is granted
 * provided that this copyright notice appears in all copies. For
 * precise terms see the accompanying LICENSE file.
 *
 * This software is provided "AS IS" with no warranty of any kind,
 * express or implied, and with no claim as to its suitability for any
 * purpose.
 *
 */

#include <lemon/lp_skeleton.h>

///\file
///\brief A skeleton file to implement LP solver interfaces
namespace lemon {
  
  int LpSkeleton::_addCol()
  {
    return ++col_num;
  }
  
  int LpSkeleton::_addRow() 
  {
    return ++row_num;
  }
  
  void LpSkeleton::_setRowCoeffs(int i, 
					       int length,
					       int  const * indices, 
					       Value  const * values )
  {
  }
  
  void LpSkeleton::_setColCoeffs(int i, 
					       int length,
					       int  const * indices, 
					       Value  const * values)
  {
  }
  
  void LpSkeleton::_setColLowerBound(int i, Value value)
  {
  }
  
  void LpSkeleton::_setColUpperBound(int i, Value value)
  {
  }
  
  void LpSkeleton::_setRowLowerBound(int i, Value value)
  {
  }
  
  void LpSkeleton::_setRowUpperBound(int i, Value value)
  {
  }
  
  void LpSkeleton::_setObjCoeff(int i, Value obj_coef)
  {
  }

  void LpSkeleton::_setMax()
  {
  }
  void LpSkeleton::_setMin()
  {
  }

  LpSkeleton::SolveExitStatus LpSkeleton::_solve()
  {
    return SOLVED;
  }

  LpSkeleton::Value LpSkeleton::_getPrimal(int i)
  {
    return 0;
  }
  
  LpSkeleton::Value LpSkeleton::_getPrimalValue()
  {
    return 0;
  }
  
  LpSkeleton::SolutionStatus LpSkeleton::_getPrimalStatus()
  {
    return OPTIMAL;
  }
  
} //namespace lemon

